
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MembershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.create(
            {
                id: data.id || undefined,
        
        role: data.role
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        joined_on: data.joined_on
        ||
        null
            ,
            
        invitation_email: data.invitation_email
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await memberships.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await memberships.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                role: item.role
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                joined_on: item.joined_on
            ||
            null
            ,
            
                invitation_email: item.invitation_email
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const memberships = await db.memberships.bulkCreate(membershipsData, { transaction });

        // For each item created, replace relation files
        

        return memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const memberships = await db.memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.role !== undefined) updatePayload.role = data.role;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.joined_on !== undefined) updatePayload.joined_on = data.joined_on;
        
        
        if (data.invitation_email !== undefined) updatePayload.invitation_email = data.invitation_email;
        
        
        updatePayload.updatedById = currentUser.id;

        await memberships.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await memberships.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of memberships) {
                await record.destroy({transaction});
            }
        });


        return memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findByPk(id, options);

        await memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await memberships.destroy({
            transaction
        });

        return memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findOne(
            { where },
            { transaction },
        );

        if (!memberships) {
            return memberships;
        }

        const output = memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await memberships.getOrganization({
            transaction
        });
        
        
        output.user = await memberships.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.invitation_email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'memberships',
                        'invitation_email',
                        filter.invitation_email,
                    ),
                };
            }
            

            
            

            
            if (filter.joined_onRange) {
                const [start, end] = filter.joined_onRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_on: {
                    ...where.joined_on,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_on: {
                    ...where.joined_on,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.role) {
                where = {
                    ...where,
                role: filter.role,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'memberships',
                        'invitation_email',
                        query,
                    ),
                ],
            };
        }

        const records = await db.memberships.findAll({
            attributes: [ 'id', 'invitation_email' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['invitation_email', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.invitation_email,
        }));
    }

    
};

